#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <random>
using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#ifdef DEBUG
	const int MAXN = 10;
	const int MAXLOG = 4;
	const int MAXSQRT = 4;
#else
	const int MAXN = 3e5;
	const int MAXLOG = 20;
	const int MAXSQRT = 400;
	#define cerr if (false) cerr
#endif

mt19937 rng(time(0));
#define int ll
const int INF = 1e9;
const int MOD = 1e9 + 7;

int b, n, m;


vector<pair<int, int>> fact(int x) {
	int q = x;
	vector<pair<int, int>> res;
	for (int i = 2; 1ll * i * i <= x; i++) {
		if (q % i == 0) {
			res.push_back({i, 0});
		}
		while (q % i == 0) {
			res.back().second++;
			q /= i;
		}
	}
	if (q != 1) {
		res.push_back({q, 1});
	}
	return res;
}

inline void init() {

}

inline void solve() {
	init();
	if (m == 1) {
		cout << 0 << '\n';
		return;
	}
	if (n == 1) {
		cout << 1 << '\n';
		return;
	}
	int cur = 1;
	for (int i = 0; i < n; i++) {
		cur *= b;
		if (cur > m) {
			break;
		}
	}
	if (cur <= m) {
		cout << "0\n";
		return;
	}
	vector<pair<int, int>> A = fact(b);
	vector<pair<int, int>> B = fact(m);
	int ans = 1;
	for (int i = 0; i < B.size(); i++) {
		bool ok = 0;
		for (int j = 0; j < A.size(); j++) {
			if (A[j].first == B[i].first) {
				ans = max(ans, (B[i].second + A[j].second - 1) / A[j].second);
				ok = 1;
			}
		}
		if (!ok) {
			ans = n;
		}
	}
	ans = min(ans, n);
	if (b == 2 && ans == n) {
		ans--;
	}
	cout << ans << '\n';
}

signed main() {
	#ifdef DEBUG
		freopen("kikos_ok.in", "r", stdin);
		freopen("kikos_ok.out", "w", stdout);
	#else
	
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	// for (b = 2; b <= 6; b++) {
	// 	for (n = 1; n <= 6; n++) {
	// 		for (m = 1; m <= 6; m++) {
	// 			cout << b << ' ' << n << ' ' << m << ": ";
	// 			solve();
	// 		}
	// 	}
	// }
	while (cin >> b >> n >> m)
		solve();
	return 0;
}
