#include <climits>
#include <iostream>
#include <map>
#include <stack>
#include <vector>
using namespace std;
using ll = long long int;
using pii = pair<int, int>;

int n;
vector<int> vec;

ll func(int pos) {
    ll sum = vec[pos];
    
    // left
    int val = vec[pos];
    for (int i = pos - 1; i >= 0; --i) {
        val = min(val, vec[i]);
        sum += val;
    }

    // right
    val = vec[pos];
    for (int i = pos + 1; i < n; ++i) {
        val = min(val, vec[i]);
        sum += val;
    }

    return sum;
}

vector<int> choose_top(int pos) {
    vector<int> res = vec;
    for (int i = pos - 1; i >= 0; --i) {
        res[i] = min(res[i], res[i + 1]);
    }
    for (int i = pos + 1; i < n; ++i) {
        res[i] = min(res[i], res[i - 1]);
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n;
    vec.resize(n);
    for (auto& it : vec) {
        cin >> it;
    }

    int l = 0, r = n - 1;
    while (r - l > 3) {
        int m1 = l + (r - l) / 3;
        int m2 = r - (r - l) / 3;
        if (func(m1) < func(m2)) {
            l = m1;
        } else {
            r = m2;
        }
    }

    ll max_val = -1;
    int max_pos = -1;
    for (int i = l; i <= r; ++i) {
        ll cur_val = func(i);
        if (cur_val > max_val) {
            max_val = cur_val;
            max_pos = i;
        }
    }
    
    auto res = choose_top(max_pos);
    for (const auto it : res) {
        cout << it << " ";
    }
    cout << endl;
}
